﻿using System;
using System.Collections.Generic;

using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using WHG.AppData;

using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.ListControls;
using Infragistics.Web.UI.DataSourceControls;

namespace WHG
{
    public partial class lrR4Data : System.Web.UI.Page
    {
        ExhibitLR4HierarchialDS hds;
        private const int FirstDataColumnNo_MainGrid = 5; ////5;   ///4; // zero based, skip those: calc, LINE, TAX_DESC, Total, --> a5, a6,...........
        private const int FirstDataColumnNo_aDJGrid = 5;   ///4; // zero based, skip those: line, idRow, TAX_DESC, Total, --> a5, a6,...........

        //counter to determine the current index
        int currentRow = 0;
        int currentCol = 0;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {

                hds = CreateHds();
                lr4whdg.DataSource = hds;
                lr4whdg.DataBind();
                Session["hds"] = hds;
            }
            else
            {
                hds = (ExhibitLR4HierarchialDS)Session["hds"];
                lr4whdg.DataSource = hds;
                lr4whdg.DataBind();
            }
        }

        //protected void Page_LoadComplete(object sender, System.EventArgs e)
        //{

        //    for (int i = FirstDataColumnNo_MainGrid; i < lr4whdg.GridView.Columns.Count; i++)
        //    {
        //        lr4whdg.GridView.Columns[i].FormatFieldMethod = new FormatRecordItemValue(FormatTotalField);  // to handle rate row 
        //    }

        //     currentRow = 0;
        //     currentCol = FirstDataColumnNo_MainGrid;
        //}
        protected void lr4whdg_DataBound(object sender, EventArgs e)
        {
            for (int i = FirstDataColumnNo_MainGrid; i < lr4whdg.GridView.Columns.Count; i++)
            {
                lr4whdg.GridView.Columns[i].FormatFieldMethod = new FormatRecordItemValue(FormatTotalField);  // to handle rate row
            }
            currentRow = 0;
            currentCol = FirstDataColumnNo_MainGrid;
        }

        //protected void Page_PreRender(object sender, System.EventArgs e)
        //{
        //    int count;
        //    count = 1; 

        //}
        protected void lr4whdg_RowUpdating(object sender, RowUpdatingEventArgs e)
        {
            //int idMain;
            //int idRow;
            
            bool ThisIsMainGrid; // i.e. parent 
          
            //   System.Threading.Thread.Sleep(5000);  // 5 sec
            e.Cancel = true;
            //DataSet CalcDS = (DataSet)Session["MrcFranData"];
            ContainerGrid g = (ContainerGrid)sender;

            if ((ControlDataField)g.FindColumn("idRow") != null)
                ThisIsMainGrid = false;
            else
                ThisIsMainGrid = true;

            g.DataBind();
            currentRow = 0; 
        //    g.RequestFullAsyncRender();

        }

        protected string FormatTotalField(ControlDataField field, object val)
        {
            if (currentRow == this.lr4whdg.Rows.Count)
            {
                currentRow = this.lr4whdg.Rows.Count - 1;
            }

            if ((string)this.lr4whdg.Rows[currentRow].Items.GetValue(1) == "TAXRATE")
            {
                if (currentCol == lr4whdg.GridView.Columns.Count - 1) // (FirstDataColumnNo_MainGrid - 1))  // start from total
                {
                    currentCol = FirstDataColumnNo_MainGrid;  // resset 
                    currentRow++;
                    return string.Format("{0:N5}", val);
                }
                currentCol++;
                return string.Format("{0:N5}", val);
            }
            else
            {
                if (currentCol == lr4whdg.GridView.Columns.Count - 1) // (FirstDataColumnNo_MainGrid - 1))  // start from total
                {
                    currentCol = FirstDataColumnNo_MainGrid;  // resset 
                    currentRow++;
                    return string.Format("{0:N0}", val);
                }
                currentCol++;
                return string.Format("{0:N0}", val);
            }
        }
        private ExhibitLR4HierarchialDS  CreateHds()
        {
            ExhibitLR4HierarchialDS hds = new ExhibitLR4HierarchialDS();
            ExhibitLR4HierarchialDS.MRC_FRANCHISE_MainRow mRow;
            ExhibitLR4HierarchialDS.MRC_FRANCHISE_AdjustRow aRow;

           mRow =  hds.MRC_FRANCHISE_Main.NewMRC_FRANCHISE_MainRow();
            mRow.idMain = 1;
            mRow.TAXNAME = "NTS";
            mRow.TAX_DESC = "NTS Descr";
            mRow.LINE = 100;
            mRow.calc = "<100>";
            mRow.Total = 1111.101;
            mRow.a5 = 1111.202;
            mRow.a6 = 1111.303;
            hds.MRC_FRANCHISE_Main.AddMRC_FRANCHISE_MainRow(mRow);

            mRow = hds.MRC_FRANCHISE_Main.NewMRC_FRANCHISE_MainRow();
            mRow.idMain = 2;
            mRow.TAXNAME = "COGS";
            mRow.TAX_DESC = "COGS Descr";
            mRow.LINE = 200;
            mRow.calc = "<200>";
            mRow.Total = 22222.101;
            mRow.a5 = 22222.202;
            mRow.a6 = 22222.303;
            hds.MRC_FRANCHISE_Main.AddMRC_FRANCHISE_MainRow(mRow);

            mRow = hds.MRC_FRANCHISE_Main.NewMRC_FRANCHISE_MainRow();
            mRow.idMain = 3;
            mRow.TAXNAME = "ADJUST";
            mRow.TAX_DESC = "ADJUST Descr";
            mRow.LINE = 300;
            mRow.calc = "<300>";
            mRow.Total = 3333.101;
            mRow.a5 = 333.202;
            mRow.a6 = 3333.303;
            hds.MRC_FRANCHISE_Main.AddMRC_FRANCHISE_MainRow(mRow);

            mRow = hds.MRC_FRANCHISE_Main.NewMRC_FRANCHISE_MainRow();
            mRow.idMain = 4;
            mRow.TAXNAME = "TAXRATE";
            mRow.TAX_DESC = "TAXRATE";
            mRow.LINE = 400;
            mRow.calc = "<400>";
            mRow.Total = 25.12345;
            mRow.a5 = 25.67891;
            mRow.a6 = 25.23456;
            hds.MRC_FRANCHISE_Main.AddMRC_FRANCHISE_MainRow(mRow);

            mRow = hds.MRC_FRANCHISE_Main.NewMRC_FRANCHISE_MainRow();
            mRow.idMain = 5;
            mRow.TAXNAME = "TAX_RESERV";
            mRow.TAX_DESC = "TAX_RESERV Descr";
            mRow.LINE = 310;
            mRow.calc = " ";
            mRow.Total = 55555.101;
            mRow.a5 = 5555.202;
            mRow.a6 = 5555.303;
            hds.MRC_FRANCHISE_Main.AddMRC_FRANCHISE_MainRow(mRow);

            //  -------------------------------------------------------
            // --------------------------------------------------------

            aRow = hds.MRC_FRANCHISE_Adjust.NewMRC_FRANCHISE_AdjustRow();
            aRow.idRow = 1;
            aRow.idMain = 3;
            aRow.TAXNAME = "ADJ1";
            aRow.TAX_DESC = "ADJ1 Descr";
            aRow.LINE = 310;
            aRow.calc = " ";
            aRow.Total = 15555.55;
            aRow.a5 = 1555.55;
            aRow.a6 = 1555.55;
            hds.MRC_FRANCHISE_Adjust.AddMRC_FRANCHISE_AdjustRow(aRow);

            aRow = hds.MRC_FRANCHISE_Adjust.NewMRC_FRANCHISE_AdjustRow();
            aRow.idRow = 2; 
            aRow.idMain = 3;
            aRow.TAXNAME = "ADJ2";
            aRow.TAX_DESC = "ADJ2 Descr";
            aRow.LINE = 320;
            aRow.calc = " ";
            aRow.Total = 2555.55;
            aRow.a5 = 2556.56;
            aRow.a6 = 2557.57;
            hds.MRC_FRANCHISE_Adjust.AddMRC_FRANCHISE_AdjustRow(aRow);

            aRow = hds.MRC_FRANCHISE_Adjust.NewMRC_FRANCHISE_AdjustRow();
            aRow.idRow = 3;
            aRow.idMain = 3;
            aRow.TAXNAME = "ADJ3";
            aRow.TAX_DESC = "ADJ3 Descr";
            aRow.LINE = 330;
            aRow.calc = " ";
            aRow.Total = 3333.101;
            aRow.a5 = 333.202;
            aRow.a6 = 3333.303;
            hds.MRC_FRANCHISE_Adjust.AddMRC_FRANCHISE_AdjustRow(aRow);

            aRow = hds.MRC_FRANCHISE_Adjust.NewMRC_FRANCHISE_AdjustRow();
            aRow.idRow = 4;
            aRow.idMain = 3;
            aRow.TAXNAME = "ADJ4";
            aRow.TAX_DESC = "ADJ4 Descr";
            aRow.LINE = 340;
            aRow.calc = " ";
            aRow.Total = 25.678;
            aRow.a5 = 25.678;
            aRow.a6 = 25.678;
            hds.MRC_FRANCHISE_Adjust.AddMRC_FRANCHISE_AdjustRow(aRow);

            aRow = hds.MRC_FRANCHISE_Adjust.NewMRC_FRANCHISE_AdjustRow();
            aRow.idRow = 5;
            aRow.idMain = 3;
            aRow.TAXNAME = "ADJ5";
            aRow.TAX_DESC = "ADJ5 Descr";
            aRow.LINE = 350;
            aRow.calc = " ";
            aRow.Total = 55555.101;
            aRow.a5 = 5555.202;
            aRow.a6 = 5555.303;
            hds.MRC_FRANCHISE_Adjust.AddMRC_FRANCHISE_AdjustRow(aRow);

            return hds;
        }
    }
}